# Method: nodes.nodes.devices.list

- [HTTP request](https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.nodes.devices/list#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.nodes.devices/list#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.nodes.devices/list#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.nodes.devices/list#body.request_body)
- [Response body](https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.nodes.devices/list#body.response_body)
- [Authorization Scopes](https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.nodes.devices/list#body.aspect)

Lists `https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/customers.deployments.devices#Device` under a `https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/customers.nodes#Node` or `https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/customers#Customer`.

### HTTP request

`GET https://sasportal.googleapis.com/v1alpha1/{parent=nodes/*/nodes/*}/devices`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The name of the parent resource. |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` The maximum number of devices to return in the response. If empty or zero, all devices will be listed. Must be in the range \[0, 1000\]. |
| `pageToken` | `string` A pagination token returned from a previous call to `https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/nodes.devices/list#spectrum.sas.portal.v1alpha1.DeviceManager.ListDevices` that indicates where this listing should continue from. |
| `filter` | `string` The filter expression. The filter should have one of the following formats: "sn=123454" or "displayName=MyDevice". sn corresponds to serial number of the device. The filter is case insensitive. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/spectrum-access-system/reference/rest/v1alpha1/ListDevicesResponse`.

### Authorization Scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/sasportal`